"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
exports.IRFunctionScope = exports.IRBlock = void 0;
var InternCache = /** @class */ (function () {
    function InternCache() {
    }
    InternCache.prototype.intern = function (o) {
        return o; // TODO
    };
    return InternCache;
}());
var MININT = -2147483648;
var MAXINT = 2147483647;
var IRType = /** @class */ (function () {
    function IRType() {
    }
    return IRType;
}());
var VoidType = /** @class */ (function (_super) {
    __extends(VoidType, _super);
    function VoidType() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.size = 0;
        _this.void = true;
        return _this;
    }
    return VoidType;
}(IRType));
var IntegerType = /** @class */ (function (_super) {
    __extends(IntegerType, _super);
    function IntegerType() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return IntegerType;
}(IRType));
var BCDType = /** @class */ (function (_super) {
    __extends(BCDType, _super);
    function BCDType() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return BCDType;
}(IntegerType));
var ParameterType = /** @class */ (function () {
    function ParameterType() {
    }
    return ParameterType;
}());
var FunctionType = /** @class */ (function (_super) {
    __extends(FunctionType, _super);
    function FunctionType() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return FunctionType;
}(IRType));
var StructType = /** @class */ (function (_super) {
    __extends(StructType, _super);
    function StructType() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return StructType;
}(IRType));
var ArrayType = /** @class */ (function (_super) {
    __extends(ArrayType, _super);
    function ArrayType() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return ArrayType;
}(IRType));
var VOID = new VoidType();
// top-level compilation unit
var IRUnit = /** @class */ (function () {
    function IRUnit() {
        this.types = new InternCache();
        this.top = new IRScope();
    }
    IRUnit.prototype.integerType = function (bits, signed) {
        if (bits != 8 && bits != 16 && bits != 24 && bits != 32)
            throw Error("invalid integer bits: " + bits);
        var t = { bits: bits, signed: signed, size: bits >> 3 };
        return this.types.intern(t);
    };
    IRUnit.prototype.voidType = function () {
        return VOID;
    };
    return IRUnit;
}());
var IRDecl = /** @class */ (function () {
    function IRDecl() {
    }
    return IRDecl;
}());
// compilation unit has a top-level scope
var IRScope = /** @class */ (function () {
    function IRScope() {
        this.decls = {};
    }
    IRScope.prototype.decl = function (ident, type) {
        // TODO: duplicate ident
        //if (this.decls[ident] != null) throw Error("Duplicate identifier: " + ident);
        this.decls[ident] = type;
    };
    return IRScope;
}());
// a value can represent up to 32 bits
// a value is assigned to a <name>
// a value has an integer range and can have partial bits set
var IRValue = /** @class */ (function () {
    function IRValue() {
    }
    return IRValue;
}());
var IRValueState = /** @class */ (function () {
    function IRValueState() {
    }
    return IRValueState;
}());
function mergeStates(a, b) {
    if (a.constval && b.constval) {
        var c = new IRValueState();
        c.constval = a.constval.merge(b.constval);
        return c;
    }
    else {
        return a || b; // TODO
    }
}
// TODO: merge with IRValue/IRValueState?
var IRConst = /** @class */ (function () {
    function IRConst(min, max, on, mask) {
        this.min = Math.max(min, MININT) | 0;
        this.max = Math.min(max, MAXINT) | 0;
        this.on = on & ~mask; // bits that are on/off
        this.mask = mask | 0; // bits that we don't know about
    }
    IRConst.prototype.merge = function (b) {
        return new IRConst(Math.min(this.min, b.min), Math.max(this.max, b.max), this.on | b.on, this.mask | b.mask);
    };
    // TODO: are these all right?
    IRConst.prototype.add = function (b) {
        var mask = this.mask | b.mask;
        return new IRConst(this.min + b.min, this.max + b.max, this.on + b.on, mask | (mask << 1)); // TODO
    };
    IRConst.prototype.sub = function (b) {
        return new IRConst(this.min - b.max, this.max - b.min, this.on - b.on, this.mask | b.mask); // TODO
    };
    // TODO: signed?
    IRConst.prototype.or = function (b) {
        var c = this.on | b.on;
        return new IRConst(Math.min(this.min, b.min), Math.max(this.max, b.max), c, (this.mask | b.mask) & ~c);
    };
    IRConst.prototype.and = function (b) {
        var c = ~this.on | ~b.on;
        var mask = (this.mask | b.mask) & c;
        return new IRConst(Math.min(this.min, b.min, 0), Math.min(this.max, b.max, mask), ~c, mask);
    };
    IRConst.prototype.xor = function (b) {
        return new IRConst(Math.min(this.min, b.min), Math.max(this.max, b.max), this.on ^ b.on, this.mask | b.mask); // TODO
    };
    IRConst.prototype.shl = function (b) {
        if (b.mask == 0)
            return new IRConst(this.min << b.on, this.max << b.on, this.on << b.on, this.mask << b.on);
        else
            return CONST_MAXINT; // TODO
    };
    IRConst.prototype.shr = function (b) {
        if (b.mask == 0)
            return new IRConst(this.max >>> b.on, this.max >>> b.on, this.on >>> b.on, this.mask >>> b.on);
        else
            return CONST_MAXINT; // TODO
    };
    IRConst.prototype.sar = function (b) {
        if (b.mask == 0)
            return new IRConst(this.max >> b.on, this.max >> b.on, this.on >> b.on, this.mask >> b.on);
        else
            return CONST_MAXINT; // TODO
    };
    return IRConst;
}());
var CONST_BOOL = new IRConst(0, 1, 0, 1);
var CONST_U8 = new IRConst(0, 0xff, 0, 0xff);
var CONST_U16 = new IRConst(0, 0xffff, 0, 0xffff);
var CONST_MAXINT = new IRConst(MININT, MAXINT, 0, -1);
var IRInsn = /** @class */ (function () {
    function IRInsn() {
    }
    IRInsn.prototype.exec = function (state) { };
    return IRInsn;
}());
var IRBlockInsn = /** @class */ (function (_super) {
    __extends(IRBlockInsn, _super);
    function IRBlockInsn() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return IRBlockInsn;
}(IRInsn));
var IRValueInsn = /** @class */ (function (_super) {
    __extends(IRValueInsn, _super);
    function IRValueInsn() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return IRValueInsn;
}(IRBlockInsn));
var IRJumpInsn = /** @class */ (function (_super) {
    __extends(IRJumpInsn, _super);
    function IRJumpInsn() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return IRJumpInsn;
}(IRInsn));
var IR_JMP = /** @class */ (function (_super) {
    __extends(IR_JMP, _super);
    function IR_JMP() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.opcode = "jmp";
        return _this;
    }
    return IR_JMP;
}(IRJumpInsn));
var IR_JNZ = /** @class */ (function (_super) {
    __extends(IR_JNZ, _super);
    function IR_JNZ() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.opcode = "jnz";
        return _this;
    }
    IR_JNZ.prototype.exec = function (state) {
        state.read(this, this.test);
    };
    return IR_JNZ;
}(IRJumpInsn));
var IR_RET = /** @class */ (function (_super) {
    __extends(IR_RET, _super);
    function IR_RET() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.opcode = "ret";
        return _this;
    }
    return IR_RET;
}(IRJumpInsn));
var IRBinopInsn = /** @class */ (function (_super) {
    __extends(IRBinopInsn, _super);
    function IRBinopInsn() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    IRBinopInsn.prototype.exec = function (state) {
        var a = state.read(this, this.left);
        var b = state.read(this, this.right);
        var c;
        if (a.constval != null && b.constval != null) {
            switch (this.opcode) {
                case 'add':
                    c = a.constval.add(b.constval);
                    break;
                case 'sub':
                    c = a.constval.sub(b.constval);
                    break;
                case 'and':
                    c = a.constval.and(b.constval);
                    break;
                case 'or':
                    c = a.constval.or(b.constval);
                    break;
                case 'xor':
                    c = a.constval.xor(b.constval);
                    break;
                case 'shl':
                    c = a.constval.shl(b.constval);
                    break;
                case 'shr':
                    c = a.constval.shr(b.constval);
                    break;
                // TODO
            }
        }
        state.write(this.assign, { constval: c });
    };
    return IRBinopInsn;
}(IRValueInsn));
var IRCompareInsn = /** @class */ (function (_super) {
    __extends(IRCompareInsn, _super);
    function IRCompareInsn() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    IRCompareInsn.prototype.exec = function (state) {
        var a = state.read(this, this.left);
        var b = state.read(this, this.right);
        // TODO: fold constants
        var c = { constval: CONST_BOOL }; // binary result
        state.write(this.assign, c);
    };
    return IRCompareInsn;
}(IRValueInsn));
var IR_COPY = /** @class */ (function (_super) {
    __extends(IR_COPY, _super);
    function IR_COPY() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.opcode = "copy";
        return _this;
    }
    IR_COPY.prototype.exec = function (state) {
        state.write(this.assign, state.read(this, this.value));
    };
    return IR_COPY;
}(IRValueInsn));
var IR_EXTS = /** @class */ (function (_super) {
    __extends(IR_EXTS, _super);
    function IR_EXTS() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.opcode = "exts";
        return _this;
    }
    return IR_EXTS;
}(IRValueInsn));
var IRMASK_TABLE = [
    0, 0xff, 0xffff, 0xffffff, 0xffffffff
];
var IR_LOAD = /** @class */ (function (_super) {
    __extends(IR_LOAD, _super);
    function IR_LOAD() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.opcode = "load";
        return _this;
    }
    IR_LOAD.prototype.exec = function (state) {
        var value = new IRValueState();
        var max = IRMASK_TABLE[this.bytes];
        value.constval = new IRConst(0, max, 0, max);
        state.write(this.assign, value);
    };
    return IR_LOAD;
}(IRValueInsn));
var IR_STORE = /** @class */ (function (_super) {
    __extends(IR_STORE, _super);
    function IR_STORE() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.opcode = "store";
        return _this;
    }
    return IR_STORE;
}(IRBlockInsn));
var IR_CALL = /** @class */ (function (_super) {
    __extends(IR_CALL, _super);
    function IR_CALL() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.opcode = "call";
        return _this;
    }
    return IR_CALL;
}(IRValueInsn));
var IRAsmInsn = /** @class */ (function (_super) {
    __extends(IRAsmInsn, _super);
    function IRAsmInsn() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    return IRAsmInsn;
}(IRBlockInsn));
var IRBlock = /** @class */ (function () {
    function IRBlock(scope, label) {
        this.states = new Map();
        this.scope = scope;
        this.label = label;
        this.insns = [];
    }
    IRBlock.prototype.append = function (insn) {
        this.insns.push(insn);
        return insn;
    };
    IRBlock.prototype.finish = function (jump) {
        if (this.jump != null)
            throw Error("block already finished");
        this.jump = jump;
        return jump;
    };
    IRBlock.prototype.load = function (assign, address, bytes) {
        var i = new IR_LOAD();
        i.bytes = bytes;
        i.assign = assign;
        i.address = address;
        return this.append(i);
    };
    IRBlock.prototype.store = function (value, address, bytes) {
        var i = new IR_STORE();
        i.bytes = bytes;
        i.value = value;
        i.address = address;
        return this.append(i);
    };
    IRBlock.prototype.copy = function (assign, value) {
        var i = new IR_COPY();
        i.assign = assign;
        i.value = value;
        return this.append(i);
    };
    IRBlock.prototype.binop = function (op, assign, left, right) {
        var i = new IRBinopInsn();
        i.opcode = op;
        i.assign = assign;
        i.left = left;
        i.right = right;
        return this.append(i);
    };
    IRBlock.prototype.cmp = function (op, assign, left, right) {
        var i = new IRCompareInsn();
        i.opcode = op;
        i.assign = assign;
        i.left = left;
        i.right = right;
        return this.append(i);
    };
    IRBlock.prototype.ret = function (value) {
        var i = new IR_RET();
        i.value = value;
        return this.finish(i);
    };
    IRBlock.prototype.jmp = function (target) {
        var i = new IR_JMP();
        i.target = target;
        return this.finish(i);
    };
    IRBlock.prototype.jnz = function (test, iftrue, iffalse) {
        var i = new IR_JNZ();
        i.test = test;
        i.iftrue = iftrue;
        i.iffalse = iffalse;
        return this.finish(i);
    };
    IRBlock.prototype.analyze = function (prevblock) {
        // already visited this block from this predecessor? exit
        if (this.states.get(prevblock) != null)
            return;
        // continue the analysis
        var state = new IRBlockState(prevblock, this);
        this.states.set(prevblock, state);
        this.insns.forEach(function (insn) { return insn.exec(state); });
        this.jump.exec(state);
        // merge into final state
        this.finalstate = state.merge(this.finalstate);
        //console.log(this.finalstate.vars);
        switch (this.jump.opcode) {
            case "jmp": {
                this.jump.target.analyze(this);
                break;
            }
            case "jnz": {
                // TODO: backfill values for true/false conditions?
                // TODO: detect const conditions?
                this.jump.iftrue.analyze(this);
                this.jump.iffalse.analyze(this);
                break;
            }
        }
    };
    IRBlock.prototype.dump = function () {
        var _this = this;
        this.insns.forEach(function (insn) {
            console.log(insn); // TODO
            if (insn instanceof IRValueInsn && insn.assign != null && insn.assign.name != null) {
                var merge = _this.finalstate.vars.get(insn.assign.name);
                console.log(insn.assign.name, '|', merge);
            }
        });
    };
    return IRBlock;
}());
exports.IRBlock = IRBlock;
var IRBlockState = /** @class */ (function () {
    // TODO: track live vars
    function IRBlockState(prev, curr) {
        this.vars = new Map();
        this.readset = new Set();
        this.prev = prev;
        this.curr = curr;
        // start this state with previous block's merged state
        if (prev != null) {
            this.vars = new Map(prev.finalstate.vars.entries());
        }
    }
    IRBlockState.prototype.read = function (insn, slot) {
        // TODO
        if (slot.readinsns == null)
            slot.readinsns = new Set();
        slot.readinsns.add(insn);
        this.readset.add(slot.name);
        return this.vars.get(slot.name) || slot;
    };
    IRBlockState.prototype.write = function (slot, value) {
        // TODO
        this.vars.set(slot.name, value); // null means unset variable
    };
    IRBlockState.prototype.merge = function (that) {
        var _this = this;
        if (that == null)
            return this; // TODO: prev should be null?
        var newstate = new IRBlockState(null, this.curr);
        var mergenames = new Set();
        for (var _i = 0, _a = Array.from(this.vars.keys()); _i < _a.length; _i++) {
            var sym = _a[_i];
            mergenames.add(sym);
        }
        for (var _b = 0, _c = Array.from(that.vars.keys()); _b < _c.length; _b++) {
            var sym = _c[_b];
            mergenames.add(sym);
        }
        mergenames.forEach(function (sym) {
            var a = _this.vars.get(sym);
            var b = that.vars.get(sym);
            if (a != null && b != null) {
                newstate.vars.set(sym, mergeStates(a, b));
            }
            else {
                newstate.vars.set(sym, a || b);
            }
        });
        return newstate;
    };
    return IRBlockState;
}());
var IRFunctionScope = /** @class */ (function () {
    function IRFunctionScope() {
        this.locals = new Map();
        this.blocks = [];
    }
    IRFunctionScope.prototype.block = function (label) {
        var b = new IRBlock(this, label);
        this.blocks.push(b);
        return b;
    };
    IRFunctionScope.prototype.temp = function (name) {
        var value = this.locals.get(name);
        if (value == null) {
            value = new IRValue();
            value.name = name;
            this.locals.set(name, value);
        }
        return value;
    };
    IRFunctionScope.prototype.const16 = function (x) {
        return this.constx(x & 0xffff);
    };
    IRFunctionScope.prototype.constx = function (x) {
        var value = this.temp("#" + (x | 0));
        value.constval = new IRConst(x, x, x, 0);
        return value;
    };
    IRFunctionScope.prototype.symaddr = function (sym) {
        return { name: '$' + sym, symbol: sym, constval: CONST_U16 };
    };
    IRFunctionScope.prototype.finish = function () {
        // TODO
        this.blocks[0].analyze(null);
    };
    IRFunctionScope.prototype.dump = function () {
        this.blocks.forEach(function (block) { return block.dump(); });
    };
    return IRFunctionScope;
}());
exports.IRFunctionScope = IRFunctionScope;
////
var RegisterState = /** @class */ (function () {
    function RegisterState() {
    }
    return RegisterState;
}());
var AsmOutput = /** @class */ (function () {
    function AsmOutput() {
    }
    return AsmOutput;
}());
var CodeEmitter6502 = /** @class */ (function () {
    function CodeEmitter6502() {
    }
    CodeEmitter6502.prototype.emitFunction = function (func) {
        var _this = this;
        func.blocks.forEach(function (block) { return _this.emitBlock(block); });
    };
    CodeEmitter6502.prototype.emitBlock = function (block) {
        // TODO
    };
    return CodeEmitter6502;
}());
////
// TODO: test
{
    var func = new IRFunctionScope();
    var block = func.block("_main");
    var block2 = func.block("@1");
    var i1 = block.load(func.temp('a'), func.symaddr('temp'), 1);
    //var i1 = block.copy(func.temp('a'), func.constx(0x123));
    var i2 = block.copy(func.temp('b'), func.constx(0x1));
    var i3 = block.binop('add', func.temp('c'), func.temp('a'), func.temp('b'));
    var i4 = block.store(i3.assign, func.constx(0x123), 1);
    var i5 = block.cmp('ult', func.temp('result'), i3.assign, func.constx(10));
    var i6 = block.jnz(i5.assign, block, block2);
    var iret = block2.ret(i3.assign);
    func.finish();
    func.dump();
}
//# sourceMappingURL=codegen.js.map